#include <windows.h>
/*cl /O1 /GF /GA /GS- /Tc friiotime.c /link /NODEFAULTLIB /ENTRY:main kernel32.lib shell32.lib shlwapi.lib user32.lib /SUBSYSTEM:WINDOWS*/
/*st@C̃pX*/
#define FRIIO_PATH L"FriioView.exe"
/*gq*/
#define EXTENSION  L".ts"

#define USE_SHLWAPI

#ifdef USE_SHLWAPI
#include <shlwapi.h>
#define wcscat  StrCatW
#define wcsncat StrNCatW
#define wcslen  WcsLen
size_t WcsLen(const wchar_t *wcs){
	size_t n;
	for(n = 0; wcs[n] != L'\0'; n++);
	return n;
}
#elif
#include <wchar.h>
#endif

/*^[R[h*/
#define TOO_LONG_FILENAME 1
#define TOO_LONG_CMDLINE  2
#define REG_WRITE_ERROR   3
#define EXCUTE_ERROR      100

#define MAX_CMDLINE 512
#define OPT_LEN 1024
#define DATETIME_LEN 32

#define CHKLEN(N) ((int)(N) < 0 ? 0 : (N))

void get_datetime_string(wchar_t *wstr, int len){
	SYSTEMTIME time;
	GetLocalTime(&time);
	/*16*/
	wsprintfW(wstr, L"-%.4hd%.2hd%.2hd-%.2hd%.2hd%.2hd", time.wYear, time.wMonth, time.wDay, time.wHour, time.wMinute, time.wSecond);
}

void make_filename(wchar_t *filename, const wchar_t *src){
	wchar_t datetime[DATETIME_LEN];
	int len = wcslen(src);

	if(len > MAX_PATH){
		ExitProcess(TOO_LONG_FILENAME);
	}
	
	filename[0] = L'\0';
	wcsncat(filename, src, MAX_PATH-1);
	/*gq̎蔲`FbN*/
	if(len > 3 &&
		filename[len-3] == L'.' &&
		filename[len-2] == L't' &&
		filename[len-1] == L's'
	){
		len -= 3;
		filename[len] = L'\0';
	}
				
	get_datetime_string(datetime, DATETIME_LEN);

	wcsncat(filename, datetime, CHKLEN(MAX_PATH-len-1));
	wcsncat(filename, EXTENSION, CHKLEN(MAX_PATH-len-wcslen(datetime)-1));
}

void main(void){
	wchar_t **wargv, options[OPT_LEN];
	int argc;
	int i;
	int return_code = EXIT_SUCCESS;
	HINSTANCE hinst;

	OutputDebugStringW(L"CommandLine : ");
	OutputDebugStringW(GetCommandLineW());
	if(wcslen(GetCommandLineW()) > MAX_CMDLINE){
		ExitProcess(TOO_LONG_CMDLINE);
	}

	wargv = CommandLineToArgvW(GetCommandLineW(), &argc);
	options[0] = L'\0';
	for (i = 1; i < argc; i++){
		if(wargv[i][0] == L'-'){
			/*t@C*/
			if(wargv[i][1] == L'f'){
				if(i < argc){
					wchar_t filename[MAX_PATH];
					i++;
					
					make_filename(filename, wargv[i]);
					/*Buffer ͏\̂͂*/
					wcscat(options, L" -f \"");
					wcscat(options, filename);
					wcscat(options, L"\"");
					continue;
				}
			}
			/*`l*/
			if(wargv[i][1] == L'c'){
				if(i < argc){
					DWORD ch;

					i++;
					/*ch = wcstoul(wargv[i], NULL)*/
					if(
							StrToIntExW(wargv[i], STIF_SUPPORT_HEX, &ch) &&
							ch > 1000
					){/*BS ch*/
						HKEY friiokey;
						if(
							RegCreateKeyExW(
								HKEY_CURRENT_USER,
								L"Software\\Friio",
								0, NULL,
								REG_OPTION_NON_VOLATILE,
								KEY_WRITE,
								NULL,
								&friiokey,
								NULL
							) == ERROR_SUCCESS
							&&
							RegSetValueExW(friiokey, L"LastChannelBS", 0, REG_DWORD, &ch, sizeof(ch))
								==ERROR_SUCCESS
						){
							OutputDebugStringW(L"LastChannelBS OK");
						}else{
							OutputDebugStringW(L"Reg write error");
							return_code = REG_WRITE_ERROR;
						}
							

					}
					wcscat(options, L" -c");
				}
			}
		}
		/*Buffer ͏\*/
		wcscat(options, L" ");
		/*wcscat(options, L"\"");*/
		wcscat(options, wargv[i]);
		/*wcscat(options, L"\"");*/
	}
	OutputDebugStringW(L"ShellExecute : ");
	OutputDebugStringW(options);
	hinst = ShellExecuteW(NULL, NULL, FRIIO_PATH, options, NULL, SW_SHOWNORMAL);
	if(hinst < 33){
		ExitProcess(EXCUTE_ERROR+(int)(hinst));
	}else{
		ExitProcess(return_code);
	}
}
